*-----
* Procedure:	GraphIt        	(Graph Field Returns Data)
*	
* Description:
*	This routine runs excel and builds the
*	graph of the data.
*	
*	The cursor TEMP contains the final form
*	of the data to be graphed.  The table
*	expected is three columns wide.
*
*	Macro Code is in Excel 5.0 format
*		but in 4.0 form, not VB!!!!!
*
* Parameters Passed:
*	nlPreview	-- Preview the graph.
*
* Parameters Returned:
*	None
*
* Maintenance Log:
*-- 02/16/1995	(KENBO)	Created by Quick Code.
*--------v---------v---------v---------v---------v---------v
Procedure GraphIt
parameters  nlPreview
private all like j*

*--	TEMP is a cursor containing the data in it's final (FLAT) form
	select TEMP
	copy to c:\graphs.xls type xls
	count to jnN
		
*--	Setup for macro BUILD
	jcMacro="c:\graphs.txt"
	jcData="c:\graphs.xls"
	jcSave="c:\graphs.xlc"
	jcTitle="Field Returns "+lcLoc+"   ("+iif(llDate,jcText,"Days in Field")+;
		" by "+iif(!llDate,jcText,"Days in Field")+")"
	jcFooter="Total Received: "+transform(jnTotal,"9,999,999")

*--	Build and Run Macro
	set message to "Building Excel Macro..."
	delete file (ncMacro)
	set textmerge on to (ncMacro) noshow
	
	&& Start macro	
	\\GRAPHS()
	\=select("R1C3")
	\=open("<<jcData>>")
	\=set.print.titles("","")
	\=set.print.area("")
	\=page.setup("","&L&D &T&C<<jcFooter>>&R<<jcName>>",0.75,0.75,0.75,0.75,FALSE,TRUE,TRUE,TRUE,1,1,100,#N/A,1,FALSE,,0.5,0.5,FALSE,FALSE)
	\

*
*	Insert Data level formating here!
*

	&& Create new chart sheet
	\=new(2,2)
	\=window.maximize()
	\=combination(1)
	\

	\=page.setup("","&L&D &T&C<<jcFooter>>&R<<jcName>>",0.75,0.75,0.75,0.75,3,FALSE,FALSE,2,1,100,1)
	\

	&& Insert data series into chart.
	\; Series Data
	\=edit.series(1,"Left Side","=graphs.xls!R1C1:R<<jnN+1>>C1","=graphs.xls!R1C2:R<<jnN+1>>C2",,1)
	\=edit.series(0,"Right Side","=graphs.xls!R1C1:R<<jnN+1>>C1","=graphs.xls!R1C3:R<<jnN+1>>C3",,2)
	
	\=select("Axis 1")
	\=scale(0)
	\

	&& Title text
	\=insert.title(true,true,true,true,"True","False")>>,false)
	\=select("title")
	\=formula("<<jcTitle>>")
	\=format.font(0,1,FALSE,"Arial",12,TRUE,FALSE,FALSE,FALSE)
	\=patterns(1,1,1,1,TRUE,1,1,1,2,,FALSE,TRUE)
	\

	&& Legend
	\=axes(true,true,false,true)
	\=legend(TRUE)
	\=select("Legend")
	\=format.font(0,1,false,"Arial",8,false,false,false,false)
	\=format.legend(3)
	\

	&& Max the graphes width.
	\=select("Plot")
	\=patterns(0,1,16,2,,0,1,1,2,,false,true)
	\=format.move(1)
	\=format.size(1000)
	\

	&& X-Axis text
	\=select("text axis 2")
	\=formula("X-Axis Text")
	\=format.font(0,1,FALSE,"Arial",10,TRUE,FALSE,FALSE,FALSE)
	\
	
	&& Y-Axis text
	\=select("text axis 1")
	\=formula("Left Side Text")
	\=format.font(0,1,FALSE,"Arial",10,TRUE,FALSE,FALSE,FALSE)
	\=format.text(2,2,0,false)
	\=format.move(1,1)
	\
	
	&& Overlay-Axis text
	\=select("text axis 3")
	\=formula("Right Side Text")
	\=format.font(0,1,FALSE,"Arial",10,TRUE,FALSE,FALSE,FALSE)
	\=format.text(2,2,0,false)
	\=format.move(780,1)
	\
	
	&& format the axis's
	\=select("Axis 2")
	\=format.text(,,2)
	\=format.font(0,1,false,"Arial",8,false,false,false,false)
	\
	
	&& Save It	
	\=save.as("<<jcSave>>",1,,FALSE,,FALSE)
	\=activate("<<jcData>>")
	\=save.as(,0)
	\=activate("<<jcSave>>")
	\

	&& Print or Preview
	if nlPreview
		\=print.preview()
	else
		\=print(1,,,1,FALSE,FALSE,1,FALSE,1)
		\=Quit()
	endif
	\=return()

	set textmerge to
	set textmerge off

*--	Start Excel
	if nnDDE<0
		jnDDE=DDEStart("EXCEL","EXCEL.EXE",3,"[Close.All()]")
		if jnDDE<0
			??chr(7)
			wait window "Unable to find Excel for windows."
			return
		endif
	else
		jnDDE=nnDDE
	endif

*--	Run Macro
	delete file (jcSave)
	set message to "Running Excel Macro..."
	=DDEExecute(jnDDE,'[Open("'+jcMacro+'")]')
	=DDEExecute(jnDDE,'[run("GRAPHS.TXT!R1C1")]')
	
*--	Wait for Excel to End
	if nnDDE<0
		=DDETerminate(jnDDE)
	endif

*--	Clean up and Exit
	set message to
	wait clear
	show gets
	do Fini

return



*-----
* Function:	DDEStart       	(DDE Startup)
*	
* Description:
*	This routine tries to establish a link
*	to the SYSTEM level of a DDE-server.  It
*	makes three attempts before failing.
*
* Parameters Passed:
*	ncDDE	-- Name of the DDE Server
*	ncProg	-- Server executable a name
*	nnMode	-- Run mode of server
*	ncCmd	-- Quick command (Close.All)
*
* Parameters Returned:
*	jnSys	-- The link number to the server.
*
* Maintenance Log:
*-- 02/16/1995	(KENBO)	Created by Quick Code.
*--------v---------v---------v---------v---------v---------v
Function DDEStart
parameter ncDDE, ncProg, nnMode, ncCmd
private jnSys, jcDDE, jnMode, jcVar, jcError

	jnMode=iif(type("nnMode")<>"N",2,nnMode)
	jcDDE=alltrim(Upper(ncDDE))
	jcProg="/N"+alltrim(str(jnMode))+" "+ncProg
	jcVar="gc"+ncDDE
	set message to "Starting "+jcDDE+"..."
	
	=DDESetOption("TIMEOUT",2500)
	=DDESetOption("SAFETY",.f.)

*--	Level 1	start.
	jnSys=DDEInitiate(jcDDE,"System")
	if jnSys<0
	
*--		Level 2 start.
		jcError=on("ERROR")
		on error do SkipErr
		! &jcProg
		on error &jcError
		
		jnSys=DDEInitiate(jcDDE,"System")
		if jnSys<0
		
*--			Level 3 Start.
			if Type(jcVar)="C" and !file(evaluate(jcVar))
				release &jcVar
			endif
			
			if type(jcVar)<>"C"
				release &jcVar
				public &jcVar
				store locfile(ncProg,"EXE","Find "+ncProg) to &jcVar
				
*--	This routine saves path to an INI file.
*
*				if !empty(evaluate(jcVar)) and file(evaluate(jcVar)) and type("gcINI")="C"
*					do WriteINI with gcINI
*				endif
*
*--	Propitaries code, unable to distribute.  -- Sorry (KENBO)

			endif
			
			jcProg="/N"+alltrim(str(jnMode))+" "+evaluate(jcVar)
			jcError=on("ERROR")
			on error do SkipErr
			! &jcProg
			on error &jcError
			jnSys=DDEInitiate(jcDDE,"System")
			
			if jnSys<0
				wait window "Can't DDE to "+jcDDE+".  Terminating link."
				return -1
			endif
		endif
	endif
	
	if type("ncCmd")="C" and !empty(ncCmd) and jnSys>-1
		=DDEExecute(jnSys,ncCmd)
	endif

return jnSys



procedure SkipErr
return

